
from qt import *
from CaseSettingsDialogTmpl import KCaseSettingsDialogTmpl
import kumula

class KCaseSettingsDialog(KCaseSettingsDialogTmpl):

    def __init__(self, parent):
        KCaseSettingsDialogTmpl.__init__(self, parent)
        self.suggestNewID()
        self.initTypeList()
        self.initUserList()


    def suggestNewID(self):
        myStatement = QString("SELECT MAX(id) FROM cases;")
        myQuery = kumula.DB.execStatement(myStatement)
        freeNr = 1
        if (myQuery.next()):
            freeNr = myQuery.value(0).toInt() + 1
        self.edNumber.setValue(freeNr)


    def initTypeList(self):
        self.cbType.clear()
        quTypes = kumula.DB.doSelect("cases_casetypes", ("id","title"), "title")
        while quTypes.next():
            myTitle = quTypes.value(1).toString()
            self.cbType.insertItem(myTitle)


    def initUserList(self):
        self.cbUser.clear()
        quCases = kumula.DB.doSelect("users", ("name","forename"), "name")
        while quCases.next():
            mySureName = quCases.value(0).toString()
            myForeName = quCases.value(1).toString()
            self.cbUser.insertItem("%s %s" % (myForeName,mySureName))


    def checkInputValues(self):
        goodValues = 1
        myNumber = self.edNumber.value()
        cntNr = kumula.DB.doCount("cases", {"id":"%i" % myNumber})
        if (cntNr > 0):
            QMessageBox.information(self, "Error", "This id is already in use<br>for another case.<br><br>I suggest a free one<br>for you...")
            self.suggestNewID()
            self.edNumber.setFocus()
            goodValues = 0
        myTitle = self.edTitle.text().stripWhiteSpace()
        if (myTitle.length() == 0):
            QMessageBox.critical(self, "Error", "You have to enter a<br>valid title for this case.")
            self.edTitle.setFocus()
            goodValues = 0
        return goodValues


    def accept(self):
        myRes = self.checkInputValues()
        if (myRes > 0):
            KCaseSettingsDialogTmpl.accept(self)


