
from RecordTypeDialogTmpl import KRecordTypeDialogTmpl
from SpecialItems import KListViewItemWithID
import kumula
from qt import QMessageBox


class KRecordTypeDialog(KRecordTypeDialogTmpl):

    def __init__(self, parent):
        KRecordTypeDialogTmpl.__init__(self, parent)
        self.updateRecordTypes()


    def updateRecordTypes(self, selectedType=0):
        if (selectedType == 0):
            if self.lvRecordTypes.currentItem():
                selectedType = self.lvRecordTypes.currentItem().tag
        self.lvRecordTypes.clear()
        quRecordTypes = kumula.DB.doSelect("cases_recordtypes", ("id","title"), "title")
        while quRecordTypes.next():
            myID    = quRecordTypes.value(0).toInt()
            myTitle = quRecordTypes.value(1).toString()
            item = KListViewItemWithID(self.lvRecordTypes, myID)
            item.setText(0, myTitle)
            if (myID == selectedType):
                self.lvRecordTypes.setSelected(item, 1)
                self.lvRecordTypes.setCurrentItem(item)



    def updateRecordTypeTitle(self):
        curItem = self.lvRecordTypes.currentItem()
        if curItem:
            self.edRecordTypeTitle.setText(curItem.text(0))


    def handleAdd(self):
        myTitle = self.edRecordTypeTitle.text().stripWhiteSpace()
        if (myTitle.length() > 0):
            kumula.DB.doInsert("cases_recordtypes", {"title":myTitle})
            self.updateRecordTypes(kumula.DB.lastAutoID())
            self.edRecordTypeTitle.clear()
        else:
            QMessageBox.critical(kumula.MainWin, "Error", "No valid title<br>for a record type.")
        self.edRecordTypeTitle.setFocus()


    def handleRename(self):
        curItem = self.lvRecordTypes.currentItem()
        if curItem:
            myNewTitle = self.edRecordTypeTitle.text().stripWhiteSpace()
            if (myNewTitle.length() > 0):
                kumula.DB.doUpdate("cases_recordtypes", {"title":myNewTitle}, {"id":"%i" % curItem.tag}, 1)
                self.updateRecordTypes(curItem.tag)
                self.edRecordTypeTitle.clear()
            else:
                QMessageBox.critical(kumula.MainWin, "Error", "No valid title<br>for a record type.")
        self.edRecordTypeTitle.setFocus()


    def handleDelete(self):
        curItem = self.lvRecordTypes.currentItem()
        if curItem:
            recordsForThisType = kumula.DB.doCount("cases_records", {"recordtype":"%i" % curItem.tag})
            if (recordsForThisType > 0):
                QMessageBox.critical(kumula.MainWin, "Error", "There are <b>%i</b> records with this type.<br><br>Please mark them as another type,<br>after that you can delete this type." % recordsForThisType)
            else:
                kumula.DB.doDelete("cases_recordtypes", {"id":"%i" % curItem.tag}, 1)
                self.updateRecordTypes()
        self.lvRecordTypes.setFocus()


