# ============================================================
# plugin.py ("CASES")
# plugin for CASES, the Kumula case management program.
# ------------------------------------------------------------
# Copyright (C) 2005 Juergen Gerner.
# ============================================================

import kumula
from qt import *
from ClientsView import KClientsView

# ------------------------------------------------------------


class cvPlugin(KClientsView):


    def getTitle(self):
        myTitle = QString("Cases")
        return myTitle


    def handleAction(self, context, action, id):
        if (context == 'case'):
            if (action == 'show'):
                self.showCase(id)
            elif (action == 'startManager'):
                self.startCaseManager()
            else:
                self.unknownCommand()
        else:
            self.unknownCommand()


    def formatRole(self, cid, aRole, aRoleID):
        myClient = KClient(cid)
        content = QString(myClient.clientName)
        content.append(' is ')
        content.append(aRole)
        content.append(' in the following cases:<br><ul>')
        count = 0
        quClientCases = kumula.DB.doSelect("cases_clients", ("caseid",), "caseid", {"clientid":cid, "clientrole":"%i" % aRoleID})
        while quClientCases.next():
            myCaseID = quClientCases.value(0).toString()
            quCases = kumula.DB.doSelect("cases", ("title","archived"), "title", {"caseid":myCaseID})
            while quCases.next():
                myTitle = quCases.value(0).toString()
                myArch  = quCases.value(1).toInt()

                myLink = self.createURL("case","show",myCaseID)
                myLink.prepend('<a href="')
                myLink.append('">')
                if (myArch > 0):
                    myTitle.prepend('<font color="#8080FF">')
                    myTitle.append('</font>')
                myTitle.prepend(myLink)
                myTitle.append('</a>')
                content.append('<li>')
                content.append(myTitle)
                content.append('</li>')
                count = count+1
        if (count == 0):
            content.append('<li><font color="#8080FF">no cases</font></li>')

        content.append('</ul>')
        return content



    def getContent(self, cid):
        content = QString('''
            <html>
            <body bgcolor="#FFFFFF" text="#000000" link="#0000FF" alink="#FF0000" vlink="#0000FF">
            <br>
            <table border="0" width="100%" cellspacing="5">
            <tr>
                <td align="left" valign="top" width="130">
                <img src="''')
        content.append(kumula.ProgramPath)
        content.append('''/lib/clients/cases/justicia.png">
                <br><br>
                <a href="''')
        content.append(self.createURL("case","startManager","0"))
        content.append('''">Start case management</a>
                </td>
                <td align="left" valign="top" width="100%">
                ''')
        content.append(self.formatRole(cid, "your <b>client</b>", 0))
        content.append('<br><br>')
        content.append(self.formatRole(cid, "your <b>contrahent</b>", 1))
        content.append('<br><br>')
        content.append(self.formatRole(cid, "a <b>3rd party</b>", 2))
        content.append('''</td>
            </tr>
            </table>
            </body>
            </html>
        ''')
        return content




    def getOLDContent(self, cid):
        myClient = KClient(cid)
        content = QString('''
            <html>
            <body bgcolor="#FFFFFF" text="#000000" link="#0000FF" alink="#FF0000" vlink="#0000FF">
            <br>
            <table border="0" width="100%" height="100%" cellspacing="5">
            <tr>
                <td align="left" valign="top" width="130">
                <img src="''')
        content.append(kumula.ProgramPath)
        content.append('''/lib/clients/cases/justicia.png">
                <br><br>
                <a href="''')
        content.append(self.createURL("case","startManager","0"))
        content.append('''">Start case management</a>
                </td>
                <td align="left" valign="top" width="100%">
                ''')
        content.append(myClient.clientName)
        content.append(' is your <u>client</u> in the following cases:<br><ul>')

        quClientCases = kumula.DB.doSelect("cases_clients", ("caseid",), "caseid", {"clientid":cid, "clientrole":"0"})
        while quClientCases.next():
            myCaseID = quClientCases.value(0).toString()
            quCases = kumula.DB.doSelect("cases", ("title","archived"), "title", {"caseid":myCaseID})
            while quCases.next():
                myTitle = quCases.value(0).toString()
                myArch  = quCases.value(1).toInt()

                myLink = self.createURL("case","show",myCaseID)
                myLink.prepend('<a href="')
                myLink.append('">')
                if (myArch > 0):
                    myTitle.prepend('<font color="#8080FF">')
                    myTitle.append('</font>')
                myTitle.prepend(myLink)
                myTitle.append('</a>')
                content.append('<li>')
                content.append(myTitle)
                content.append('</li>')

        content.append('</ul><br><br>')
        content.append(myClient.clientName)
        content.append(' is your <u>contrahent</u> in the following cases:<br><ul>')

        quClientCases = kumula.DB.doSelect("cases_clients", ("caseid",), "caseid", {"clientid":cid, "clientrole":"1"})
        while quClientCases.next():
            myCaseID = quClientCases.value(0).toString()
            quCases = kumula.DB.doSelect("cases", ("title","archived"), "title", {"caseid":myCaseID})
            while quCases.next():
                myTitle = quCases.value(0).toString()
                myArch  = quCases.value(1).toInt()

                myLink = self.createURL("case","show",myCaseID)
                myLink.prepend('<a href="')
                myLink.append('">')
                if (myArch > 0):
                    myTitle.prepend('<font color="#8080FF">')
                    myTitle.append('</font>')
                myTitle.prepend(myLink)
                myTitle.append('</a>')
                content.append('<li>')
                content.append(myTitle)
                content.append('</li>')

        content.append('''</ul>
                </td>
            </tr>
            </table>
            </body>
            </html>
        ''')
        return content




    def showCase(self, aCaseID):
        print "Starting CaseData with case %s..." % aCaseID
        kumula.runKumulaApp("casedata", {"case":aCaseID})


    def startCaseManager(self):
#        print "Starting Cases..."
        kumula.runKumulaApp("cases")


    def moduleMenuItems(self):
        myItems = ("New case", "Case management")
        return myItems


    def handleMenuItem(self, nr):
        if (nr == 0):
            self.showCase("")
        elif (nr == 1):
            self.startCaseManager()


